% DBlockToolbox Main Directory, Version 100
% 
% This is the main directory of the DBlockToolbox package with additional transform utilities;
% DBlockToolbox is a collection of .m functions for 2D block denoising and deconvolution under
% Gaussian noise. It REQUIRES at least WaveLab802 installed to work properly.
%
%              .m files in this directory
%
%   Contents.m          -    This file
%   DBlockToolboxPath.m -    Sets up global variables and pathnames
%   README		-    Short package description.
%   INSTALL		-    Installation instruction.
%   VERSION		-    Version history.
%   THANKS
%
%              Subdirectories
%
%   Denoising       	-    Denoising functions.
%   Deconvolution       -    Deconvolution functions. 
%   UDWT                -    UDWT RWT package (DSP Rice). 
%			     Mex files have been compiled for Linux/Unix Solaris/MACOSX and Windows platforms.
%   CurveletToolbox	-    Fast curvelet transform toolbox (Candes et al. curvelet.org).
%			     Two fast curvelet transform codes are included:
%				+ CURVWRAP: Mex Wrapping code. Mex files have been compiled for Linux/Unix Solaris/MACOSX platforms.
%			         If you are running Windows, please compile your own mex. Note that fdct_wrapping.m and ifdct_wrapping.m 
%				 have been slightly modified to handle curvelets at all scales.
%   Datasets		-    Some test images.
%   Scripts		-    Scripts to reproduce figures.
%   Utils		-    Utilities.
%
% N.B.:	(i) DBlockToolbox incorporates software for two other transforms not distributed with WaveLab. For instance 
%	    the wrapping version of the Fast Discrete Curvelet Transform implemented in CurveLab, and the UDWT from the RWT toolbox. 
%	    Note that some of the CurveLab functions have been slightly modified to match our data structure, 
% 	    and to implement curvelets at the finest scale. We strongly recommend that the user downloads our modified version 
% 	    included in DBlockToolbox. Both of these transforms are are in the subdirectories DBlockToolbox/CurveleToolbox and
% 	    DBlockToolbox/UDWT. 
%	    The user is invited to read carefully the license agreement details of these transforms softwares on their respective 
% 	    websites prior to any use.
%	(ii) To compare to BLS-GSM, you must download and install BLS-GSM of J. Portilla. 
% 	    Otherwise, comment appropriate lines in the scripts. Note that denoi_BLS_GSM.m included in our toolbox 
%	    is a slight modification of the original function in BLS-GSM toolbox to be able to handle curvelets.
% 	  
%
% References:
%
%   C. Chesneau, M.J. Fadili and J.-L. Starck. Stein Block Thresholding For Image Denoising, 2008.
%
%






%
% Part of DBlockToolbox Version:100
% Written by: Jalal Fadili, GREYC CNRS ENSICAEN
%             Christophe Chesneau, LMNO University of Caen
%             Jean-Luc Starck, CEA-CNRS
% Created June 2008
% This material is distributed under CeCiLL licence.
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
% 
