%  DBlockToolbox100 -- initialize path to include DBlockToolbox
%
    global DBLOCKPATH
    DBLOCKPATH = 100;
    BVstr=num2str(DBLOCKPATH);
    
	fprintf('\nWelcome to DblockToolbox v %g\n\n', DBLOCKPATH);
%
	global DBLOCKPATHPATH
	global PATHNAMESEPARATOR
	global MATLABPATHSEPARATOR
   	
%
	Friend = computer;
	if strcmp(Friend,'MAC2'),
	  PATHNAMESEPARATOR = ':';
	  DBLOCKPATHPATH = ['Macintosh HD:Build:DBlockToolbox', BVstr, PATHNAMESEPARATOR];
	  MATLABPATHSEPARATOR = ';';
	elseif isunix,
	  PATHNAMESEPARATOR = '/';
	  [s,HOME]	    = unix('echo $HOME');
	  DBLOCKPATHPATH = [pwd, PATHNAMESEPARATOR];
	  MATLABPATHSEPARATOR = ':';
	elseif strcmp(Friend(1:2),'PC');
	  PATHNAMESEPARATOR = '\';	  
	  DBLOCKPATHPATH = [matlabroot,'\toolbox\DBlockToolbox', BVstr, PATHNAMESEPARATOR];  
	  MATLABPATHSEPARATOR = ';';
	else
		disp('I don''t recognize this computer; ')
		disp('Pathnames not set; solution: edit DBlockToolboxPath.m\n\n')
	end
%
	global MATLABVERSION
	V = version;
	MATLABVERSION = str2num(V(1:3));

    if MATLABVERSION < 5.3,
        disp('Warning: This version is only supported on Matlab 6.x and higher');
        DBLOCKPATHtoolbox=genpath(DBLOCKPATHPATH,1);
    else
        DBLOCKPATHtoolbox=genpath(DBLOCKPATHPATH);
    end
    
    path(DBLOCKPATHtoolbox,path);  
     
%
	fprintf('Setting Global Variables:\n');
	fprintf('   global MATLABVERSION = %g\n',	MATLABVERSION)
	fprintf('   global DBLOCKPATHPATH = %s\n',	DBLOCKPATHPATH)
    
%
	fprintf('   DBlockToolbox Path set successfully.\n');
	
% Check if WaveLab802 is installed. Just test if FWT_PO is in the path.
	if isempty(which('FWT_PO')),
		error('WaveLab does not seem to be installed, please check ...');
	end




%
% Part of DBlockToolbox Version:100
% Written by: Jalal Fadili, GREYC CNRS ENSICAEN
%             Christophe Chesneau, LMNO University of Caen
%             Jean-Luc Starck, CEA-CNRS
% Created June 2008
% This material is distributed under CeCiLL licence.
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
% 
