function [pdfhat,t]=density(x,qmf,thd,nbins,p,L)

if (exist('x')~=1),     error('Provide input image');           end;
if (exist('qmf')~=1),   qmf = MakeONFilter('Symmlet',6);        end;
if (exist('thd')~=1),   thd = 4.5;                              end;
if (exist('nbins')~=1), nbins = length(x);        		end;

J   = nextpow2(nbins); 
n   = length(x);
[t,pdf] = fasthist(x(:)',nbins);dt=t(2)-t(1);pdf=pdf/sum(pdf)/dt;
if (exist('L')~=1)	L     = 2^floor(log2(log(nbins)^(max(p,2)/2))); end;
scale = floor(max(p,2)/2*log2(log(nbins)));

if L >= n,
	disp('Taille du bloc trop grande.');
	pdfhat = [];t = [];
	return;
end

w     = what(t,1);
muhat = 1;%nbins/sum(1./w(:));
%plot([pdf' pdf'./w']);drawnow;pause
wc = FWT_PO(muhat*pdf./w,scale,qmf);

for j = 0:J-1-scale
  buf = wc(2^(J-j-1)+1 : 2^(J-j));
  buf = reshape(buf,L,floor(2^(J-j-1)/L));
  bufmask = ((sum(abs(buf).^p,1)/L).^(1/p)) >= thd;
  buf = buf .* repmat(bufmask,L,1);
  wc(2^(J-j-1)+1 : 2^(J-j)) = buf(:);
end

pdfhat = IWT_PO(wc,scale,qmf);


function z=what(t,theta)

%z = exp(-t.^2/(2*theta^2));
z = (sqrt(t.*(1-t)).*sin(2*pi*1.05./(t+1.05))+1);
