function [pdfhat,t]=density(x,qmf,nbins,L)

if (exist('x')~=1),     error('Provide input image');           end;
if (exist('qmf')~=1),   qmf = MakeONFilter('Symmlet',6);        end;
if (exist('nbins')~=1), nbins = length(x);        		end;

J   = nextpow2(nbins); 
n   = length(x);
[t,pdf] = fasthist(x(:)',nbins);dt=t(2)-t(1);pdf=pdf/sum(pdf)/dt;
if (exist('L')~=1)	L     = 2^floor(log2(log(nbins))); end;
scale = floor(log2(log(nbins)));
thd = 4.5;

if L >= n,
	disp('Taille du bloc trop grande.');
	pdfhat = [];t = [];
	return;
end

wc = FWT_PO(pdf,scale,qmf);

for j = 0:J-1-scale
  buf = wc(2^(J-j-1)+1 : 2^(J-j));
  buf = reshape(buf,L,floor(2^(J-j-1)/L));
  bufmask = sqrt(sum(abs(buf).^2,1)/L) >= thd;
  buf = buf .* repmat(bufmask,L,1);
  wc(2^(J-j-1)+1 : 2^(J-j)) = buf(:);
end

w = what(t,1);
muhat = 1;%nbins/sum(1./w(:));
pdfhat = muhat*IWT_PO(wc,scale,qmf)./w;

function z=what(t,theta)

%z = exp(-t.^2/(2*theta^2));
z = (sqrt(t.*(1-t)).*sin(2*pi*1.05./(t+1.05))+1);
