clear all
N     = 2^16;
nbins = 2^10;
p     = linspace(1,5,20);
MC    = 10;
thd   = 2*sqrt(2*p);
theta = 1;
qmf   = MakeONFilter('Symmlet',6);
randn('state',0);

for ip=1:length(p)
for rep=1:MC
 z = rand(N,1);

 [pdfhat,t] = density(z,qmf,thd(ip),nbins,p(ip));

 dt = t(2)-t(1);
 f = @(t)(1./(sqrt(t.*(1-t)).*sin(2*pi*1.05./(t+1.05))+1));
 pdfth = f(t+dt/2);

 lprisk(rep,ip) = norm(pdfth(:)-pdfhat(:),p(ip));
end
end

plot(p,mean(lprisk));grid
xlabel('p');ylabel('L_p risk');

[p' mean(lprisk)' std(lprisk)']

