clear all
N     = 2^16;
nbins = 2^16;
p     = 2;
thd   = 2*sqrt(2*p);
theta = 1;
qmf   = MakeONFilter('Symmlet',6);

%z = rayl_rnd(theta,N,1);
z = rand(N,1);

[pdfhat,t] = density(z,qmf,thd,nbins,p);
[pdfhatnaive,t] = densitynaive(z,qmf,nbins);

dt = t(2)-t(1);
f = @(t)(1./(sqrt(t.*(1-t)).*sin(2*pi*1.05./(t+1.05))+1));
pdfth = f(t+dt/2);

subplot(121);
plot(t,pdfhat(:),'-b',t,pdfth(:),'--b');axis tight;grid
legend('Estimated block','Original');
title(sprintf('L_2 error %f',norm(pdfth(:)-pdfhat(:),p)));
subplot(122);
plot(t,pdfhatnaive(:),'-b',t,pdfth(:),'--b');axis tight;grid
legend('Estimated naive','Original');
title(sprintf('L_2 error %f',norm(pdfth(:)-pdfhatnaive(:),p)));

  
