clear all
close all
images = {'barbara_512x512.png','lena512x512.png','peppers256.png'};
randn('state',0);
sigma=20;
qmf=MakeONFilter('Symmlet',6);

for in=1:length(images)
 img=double(imread(images{in}));
 img=255*img/max(img(:));
 imnoisy=img+sigma*randn(size(img));

 disp('DWT Block');
 tic;imden=den2d_block(imnoisy,qmf,4.5,4,sigma);timeblock(in,1)=toc;
 disp('DWT BLS');
 repres1 = 'w';repres2 = 'daub4';Nor = 3;Nsc = nextpow2(length(img)) - 3;
 tic;imdenbls=denoi_BLS_GSM(imnoisy, sigma, ones(size(img)), [3 3], 0, 0, Nsc, Nor, 1, 1, repres1, repres2, 0);timebls(in,1)=toc;
    
 disp('UDWT Block');
 tic;imdenTI=den2d_blockTI(imnoisy,qmf,4.5,4,sigma);timeblock(in,2)=toc;
 disp('UDWT BLS');
 repres1 = 'uw';repres2 = 'daub4';Nor = 3;Nsc = nextpow2(length(img)) - 3;
 tic;imdenTIbls=denoi_BLS_GSM(imnoisy, sigma, ones(size(img)), [3 3], 0, 0, Nsc, Nor, 1, 1, repres1, repres2, 0);timebls(in,2)=toc;

 disp('Curvelets Block');
 tic;[imdenC,cput]=den2d_blockcurvwrap(imnoisy,5,4.5,4,sigma);timeblock(in,3)=toc-cput(2); % Correct for one atom normalization step.
 disp('Curvelets BLS');
 repres1 = 'cw';repres2 = '';Nor = [];Nsc = nextpow2(length(img)) - 5;
 tic;imdenCbls=denoi_BLS_GSM(imnoisy, sigma, ones(size(img)), [3 3], 0, 0, Nsc, Nor, 1, 1, repres1, repres2, 0);timebls(in,3)=toc;
 % Correct the BLS CPU time from two atom normalization steps,
 % whose CPU time is twice the second component of cput vector.
 timebls(in,3)=timebls(in,3)-2*cput(2);

        
 figure
 colormap('gray');
 subplot(421)
 imagesc(img);axis image;axis off
 title('Original');
 subplot(422)
 imagesc(imnoisy);axis image;axis off
 title(sprintf('Noisy \\sigma=%d PSNR_{in}=%.2f dB',sigma,20*log10(255./sigma)));
 
 subplot(423)
 imagesc(imden);axis image;axis off
 title(sprintf('DWT Block PSNR=%.2f dB',psnr(img(:),imden)));
 subplot(424)
 imagesc(imdenbls);axis image;axis off
 title(sprintf('DWT BLS PSNR=%.2f dB',psnr(img(:),imdenbls)));

 subplot(425)
 imagesc(imdenTI);axis image;axis off
 title(sprintf('UDWT Block PSNR=%.2f dB',psnr(img(:),imdenTI)));
 subplot(426)
 imagesc(imdenTIbls);axis image;axis off
 title(sprintf('UDWT BLS PSNR=%.2f dB',psnr(img(:),imdenTIbls)));

 subplot(427)
 imagesc(imdenC);axis image;axis off
 title(sprintf('Curvelets Block PSNR=%.2f dB',psnr(img(:),imdenC)));
 subplot(428)
 imagesc(imdenCbls);axis image;axis off
 title(sprintf('Curvelets BLS PSNR=%.2f dB',psnr(img(:),imdenCbls)));
 
 fprintf('%s\n','*'*ones(1,90));
 fprintf('%30sCPU (s) for %s\n',' ',images{in});
 fprintf('%s\n','*'*ones(1,90));
 fprintf('%-10s%-15s\t%-15s\t%-15s\n',' ','DWT','UDWT','Curvelets');
 fprintf('%-10s%-15.2g\t%-15.2g\t%-15.2g\n','Block', timeblock(in,1),timeblock(in,2),timeblock(in,3));
 fprintf('%-10s%-15.2g\t%-15.2g\t%-15.2g\n','BLS'  , timebls(in,1),timebls(in,2),timebls(in,3));
end


%
% Part of DBlockToolbox Version:100
% Written by: Jalal Fadili, GREYC CNRS ENSICAEN
%             Christophe Chesneau, LMNO University of Caen
%             Jean-Luc Starck, CEA-CNRS
% Created June 2008
% This material is distributed under CeCiLL licence.
% E-mail: Jalal.Fadili@greyc.ensicaen.fr
% 
